<app-loading *ngIf="isLoading"></app-loading>
<div class="app-card">
  <form nz-form [formGroup]="formSearch">
    <div class="report-row" nz-row [nzGutter]="[30, 0]">
      <ng-template inp-generate></ng-template>
      <div nz-col nzXs="24" nzLg="24" class="report-btn-center">
        <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE"
                   (click)="showModal()" [mbButtonIsLoading]='isRunReport' [mbIsDisable]='isRunReport'
                   mbButtonAvailableStyle="LOADING" mbButtonText="{{'reports.button.runReport' | translate}}"></mb-button>
        <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="downLoadReport(reportId, fileName)" mbType='SUBMIT'
                   *ngIf='reportId != null && !isRunReport && reportStatus === constant.REPORT_HISTORY_STATUS_VALUE.CREATED'
                   mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'reports.button.download' | translate}}"></mb-button>
        <mb-button mbButtonType="BORDER" mbButtonSize="LARGE" (click)="cancel(reportId)" mbType='SUBMIT'
                   *ngIf='reportId != null && isRunReport'
                   mbButtonAvailableStyle="DEFAULT" mbButtonText="{{'reports.button.cancel' | translate}}"></mb-button>
      </div>
    </div>
  </form>
</div>
<div class="app-list">
  <mb-table-merge-cell-wrap>
    <div nz-row class='label__divider--wrap'>
      <div nz-col [nzXs]='21' [nzLg]='21' class='input__group'>
        <label
          class='label__divider'>{{'reports.label.history' | translate}}</label>
      </div>
    </div>
    <mb-table-merge-cell
      (changePageNum)="searchReportHistory($event)"
      [tableConfig]="tableConfig"
      [dataList]="listData"
      [isScrollHeight]="true"
      nzScrollHeight="45vh"
    ></mb-table-merge-cell>
  </mb-table-merge-cell-wrap>
</div>

<ng-template #actionTmpl let-id='reportId' let-fileName='fileName' let-status='flagStatus'>
  <a *ngIf='status === constant.REPORT_HISTORY_STATUS_VALUE.CREATED || status === constant.REPORT_HISTORY_STATUS_VALUE.COMPLETE'
     (click)='downLoadReport(id, fileName)' class='action'>{{'reports.button.download' | translate}}</a>
  <a *ngIf='status === constant.REPORT_HISTORY_STATUS_VALUE.RETRIEVING_DATA'
     (click)='cancel(id)' class='action cancel'>{{'reports.button.cancel' | translate}}</a>
</ng-template>

<!-- Trạng thái -->
<ng-template #statusTmpl let-status='flagStatus'>
  <ng-container *ngFor='let item of constant.REPORT_HISTORY_STATUS'>
    <nz-tag [nzColor]="item.bgColor" [ngStyle]="{'color': item.color}" *ngIf='status?.toString() === item.value'>{{item.label | translate}}</nz-tag>
  </ng-container>
</ng-template>
<!--End: Trạng thái-->

<ng-template #selectModalTmpl>
  <app-loading *ngIf="isLoadingModal"></app-loading>
  <mb-select
    [mbDataSelects]='listReportType'
    mbKeyLabel='templateFormatLabel'
    mbKeyValue='templateFormatValue'
    mbPlaceholder="{{'reports.label.fileType' | translate}}"
    [(ngModel)]='fileType'></mb-select>
</ng-template>

<ng-template #selectModalFooterTmpl>
  <mb-button mbButtonType="BORDER"  mbButtonSize="LARGE" (click)="handleCancel()" mbButtonBgColor="transparent"
             mbButtonAvailableStyle="DEFAULT" mbButtonText="{{'common.button.cancel' | translate}}"></mb-button>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="runReport()" *ngIf='fileType'
             mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.select' | translate}}"></mb-button>
</ng-template>

